
var App=(function(){var app;var chromeInteractive=false;init();initOverlay();document.body.classList.toggle('large-text',navigator.largeTextEnabled);window.addEventListener('largetextenabledchanged',function(){document.body.classList.toggle('large-text',navigator.largeTextEnabled);});function init(){navigator.mozL10n.once(function onLocalizationInit(){window.performance.mark('navigationLoaded');initDB();ListView.init();SubListView.init();SearchView.init();TabBar.init();setStartMode();if(ModeManager.currentMode!==MODE_PICKER){ListView.activate({option:'playlist'});}
navigator.mozL10n.ready(function(){ModeManager.updateTitle();if(!chromeInteractive){chromeInteractive=true;window.performance.mark('navigationInteractive');}});});}
function setStartMode(){if(document.URL.indexOf('#pick')!==-1){navigator.mozSetMessageHandler('activity',function activityHandler(a){var activityName=a.source.name;if(activityName==='pick'){app.pendingPick=a;}});TabBar.option='title';ModeManager.start(MODE_PICKER);}else{TabBar.option='playlist';ModeManager.start(MODE_LIST);}}
function initOverlay(){var overlay=document.getElementById('overlay');overlay.addEventListener('keydown',(e)=>{if(e.key==='Enter'){window.close();}});SoftKeyStore.register({center:'ok',},overlay);}
function showOverlay(id){if(OptionMenu.element.classList.contains('hidden')){document.activeElement.blur();}
app.currentOverlay=id;function setVisibility(visible){Array.forEach(document.body.children,function(elt){if(elt.id==='overlay'){elt.classList.toggle('hidden',!visible);visible&&elt.focus();}else if(elt.id==='region-views'){elt.classList.toggle('hidden',visible);}else{elt.setAttribute('aria-hidden',visible);}});}
if(id===null){setVisibility(false);return;}
var l10nIds={'title':id+'-title','text':id+'-text'};if(id==='nocard'){l10nIds.title='nocard2-title';l10nIds.text='nocard3-text';}
var textElement=document.getElementById('overlay-text');textElement.dataset.l10nId=l10nIds.text;setVisibility(true);}
function showCorrectOverlay(count){if(typeof count==='undefined'||count>0){app.showOverlay(null);}else if(reparsingMetadata){app.showOverlay('upgrade');}else{app.showOverlay('empty');}}
function showCurrentView(callback){LazyLoader.load('js/metadata/album_art.js',function(){function showListView(){var option=TabBar.option;var info={key:'metadata.'+option,range:null,direction:(option==='title')?'next':'nextunique',option:option};ListView.activate(info);}
if(app.pendingPick||ModeManager.currentMode===MODE_LIST){showListView();callback&&callback();}
window.dispatchEvent(new CustomEvent('visuallyLoaded'));window.performance.mark('visuallyLoaded');window.performance.mark('contentInteractive');});}
app={pendingPick:null,currentOverlay:null,knownSongs:[],showOverlay:showOverlay,showCorrectOverlay:showCorrectOverlay,showCurrentView:showCurrentView};return app;})();